drop procedure REGLASVAL;
CREATE OR REPLACE PROCEDURE REGLASVAL
(lFOLIOCTR IN number) is

 FolioValCtr number;
 Cont        number          default 0;
 ContErr     number          default 0;
 sQueryRegla varchar2(3000);
 sRespRegla1 varchar2(500);
 sRespRegla2 varchar2(500);
 sRespRegla3 varchar2(500);
 sRespRegla4 varchar2(500);
 sRespRegla5 varchar2(500);

 type tRegla is record (
      Cod_Regla  Regla_Emision_Contrato.Cod_Regla_Emision_Ctr%type,
      Tipo_Regla Regla_Emision_Contrato.Tipo_Regla_Emision_Ctr%type,
      Mensaje    Message.Lib_msg%type,
      Query      Regla_Emision_Contrato.Query_Sql_Regla_Emision_Ctr%type,
      Num_Campos Regla_Emision_Contrato.Num_Campos_Query_Regla_Ctr%type);
 Regla tRegla;

 TYPE ReglaCurTyp IS REF CURSOR;
 cQueryRegla ReglaCurTyp;

 cursor cReglas is
	SELECT REC.Cod_Regla_Emision_Ctr, 
	       REC.Tipo_Regla_Emision_Ctr,
	       MES.Lib_msg, 
	       REC.Query_Sql_Regla_Emision_Ctr,
	       REC.Num_Campos_Query_Regla_Ctr 
	  FROM Message MES, 
	       Regla_Emision_Contrato REC
	 WHERE MES.Code_Msg = REC.Cod_Msj 
	 ORDER BY REC.Cod_Regla_Emision_Ctr;

BEGIN

SELECT Folio_Validacion_Ctr
  INTO FolioValCtr 
  FROM Validacion_Contrato VC
 WHERE Folio_ctr = lFOLIOCTR
   AND Fecha_creacion_validacion_ctr = 
	    (SELECT MAX(Fecha_creacion_validacion_ctr)
	       FROM Validacion_Contrato 
	      WHERE Folio_ctr = lFOLIOCTR);

dbms_output.put_line('Folio_Validacion_Ctr: ' || FolioValCtr);

if FolioValCtr = NULL then
   dbms_output.put_line('Obtiene Folio Nuevo');
   SELECT VCTR_SEQ.NEXTVAL
     INTO FolioValCtr
     FROM Dual;

   dbms_output.put_line('Folio_Validacion_Ctr Nuevo: ' || FolioValCtr);

   INSERT INTO Validacion_Contrato
	 (Folio_Validacion_ctr,
          Folio_Ctr,
          Fecha_Validacion_Ctr,
          Fecha_Rechazo_Ctr,
          Es_Emitido_Ctr)
   VALUES(FolioValCtr, 
	  lFOLIOCTR, 
	  SYSDATE, 
	  NULL, 
	  'N');
end if;


dbms_output.put_line('Borra Error_Validacion_Contrato');

DELETE Error_Validacion_Contrato
 WHERE Folio_Validacion_Ctr = FolioValCtr;

if sql%notfound then
   dbms_output.put_line('No hay Renglones');
end if;

dbms_output.put_line('Abre Cursor de Reglas');
OPEN cReglas;

loop

   FETCH cReglas
   INTO Regla;
   EXIT WHEN cReglas%notfound;

   Cont := Cont+1;

   dbms_output.put_line('Regla ' || Cont || ' Cod Regla [' || Regla.Cod_Regla || ']');

   sQueryRegla := RemplazaCadena(Regla.Query, lFOLIOCTR);

   Begin
      dbms_output.put_line('Ejecuta Regla');
      OPEN cQueryRegla FOR sQueryRegla;
      loop

         dbms_output.put_line('Obtiene datos de la Regla');
         if Regla.Num_Campos = 1 then
            FETCH cQueryRegla
             INTO sRespRegla1;
         elsif Regla.Num_Campos = 2 then
            FETCH cQueryRegla
             INTO sRespRegla1,
	          sRespRegla2;
         elsif Regla.Num_Campos = 3 then
            FETCH cQueryRegla
             INTO sRespRegla1,
	          sRespRegla2,
	          sRespRegla3;
         elsif Regla.Num_Campos = 4 then
            FETCH cQueryRegla
             INTO sRespRegla1,
	          sRespRegla2,
	          sRespRegla3,
	          sRespRegla4;
         elsif Regla.Num_Campos = 5 then
            FETCH cQueryRegla
             INTO sRespRegla1,
	          sRespRegla2,
	          sRespRegla3,
	          sRespRegla4,
	          sRespRegla5;
         end if;
	 EXIT WHEN cQueryRegla%notfound;

      End loop;
      if sRespRegla1 is not Null then
	  ContErr := ContErr + 1;
      end if;
   Exception
      When no_data_found then null;
   End;

end loop;

dbms_output.put_line('Cierra el Cursor cReglas');
close cReglas;
dbms_output.put_line('Num Errores: ' || ContErr);

END;
/
